package ContactLens::Util;
{
  $ContactLens::Util::VERSION = '0.132151';
}

use strict;
use warnings;
use base 'Exporter';

our @EXPORT_OK = qw(looks_like_ax looks_like_bc looks_like_cy looks_like_dia looks_like_pw);

my $DECIMAL_RE = qr/[+-]?\d+(?:\.\d{1,2}(?!\d))?/;
my $INT_RE     = qr/[+-]?\d+(?!\.)/;

sub looks_like_pw {
    my $num = _single($DECIMAL_RE, @_) // return;

    -15.00 <= $num and $num <= 5.0;
}

sub looks_like_dia {
    my $num = _single($DECIMAL_RE, @_) // return;

    8.00 <= $num and $num <= 14.80;
}

sub looks_like_cy {
    my $num = _single($DECIMAL_RE, @_) // return;

    -2.75 <= $num and $num <= +0.75; 
}

sub looks_like_bc {
    my $num = _single($DECIMAL_RE, @_) // return;

    7.20 <= $num and $num <= 9.30;
}

sub looks_like_ax {
    my $num = _single($INT_RE, @_) // return;

    10 <= $num and $num <= 180;
}

sub _single {
    my ($re, $str) = @_;

    my @nums = $str =~ /($re)/g;

    @nums == 1 ? $nums[0] : undef;
}

1;
